//
//  ViewController.m
//  JSONvsXML_ObjC
//
//  Created by Torrey Betts on 4/15/16.
//  Copyright (c) 2016 Infragistics. All rights reserved.
//


#import "ViewController.h"
#import "igXMLParser.h"


@interface ViewController ()

@end

@implementation ViewController


- (void)viewDidLoad
{
    [super viewDidLoad];

    for (int i = 0; i < 10; ++i)
    {
        NSString *executionString = [NSString stringWithFormat:@"Test Run %d: ", i + 1];

        NSDate *methodStart = [NSDate date];
        NSArray *employeesXML = [self getAllEmployeesXML];
        NSDate *methodFinish = [NSDate date];
        executionString = [[NSString alloc] initWithFormat:@"%@ XML Time: %f seconds ", executionString, [methodFinish timeIntervalSinceDate:methodStart]];

        methodStart = [NSDate date];
        NSArray *employeesJSON = [self getAllEmployeesJSON];
        methodFinish = [NSDate date];
        executionString = [[NSString alloc] initWithFormat:@"%@ JSON Time: %f seconds ", executionString, [methodFinish timeIntervalSinceDate:methodStart]];
        NSLog(@"%@", executionString);
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

- (NSArray *)getAllEmployeesXML
{
    NSMutableArray *employees = [[NSMutableArray alloc] init];

    igXMLParser *parser = [[igXMLParser alloc] init];
    NSString *filePath = [[NSBundle mainBundle] pathForResource:@"SouthWind" ofType:@"xml"];
    NSData *data = [NSData dataWithContentsOfFile:filePath];
    igXMLElement *root = [parser parseXmlWithData:data];
    igXMLElement *employeeRoot = [root findElementByName:@"Employees"][0];
    for (igXMLElement *child in employeeRoot.subElements)
    {
        igXMLElement *lastNameElement = [child findElementByName:@"LastName"][0];
        igXMLElement *firstNameElement = [child findElementByName:@"FirstName"][0];
        NSString *name = [NSString stringWithFormat:@"%@ %@", firstNameElement.text, lastNameElement.text];
        [employees addObject:name];
    }

    return employees;
}

- (NSArray *)getAllEmployeesJSON
{
    NSMutableArray *employees = [[NSMutableArray alloc] init];

    NSString *filePath = [[NSBundle mainBundle] pathForResource:@"SouthWind" ofType:@"json"];
    NSData *data = [NSData dataWithContentsOfFile:filePath];
    NSError *error = nil;
    NSDictionary *root = [NSJSONSerialization JSONObjectWithData:data options:NSJSONReadingMutableContainers error:&error];
    NSDictionary *rootData = root[@"windward-studios"];
    NSDictionary *employeesRoot = rootData[@"Employees"];
    NSArray *employeesAll = employeesRoot[@"Employee"];

    for (int i = 0; i < employeesAll.count; ++i)
    {
        NSString *lastName = employeesAll[i][@"LastName"];
        NSString *firstName = employeesAll[i][@"FirstName"];
        NSString *name = [NSString stringWithFormat:@"%@ %@", firstName, lastName];
        [employees addObject:name];
    }

    return employees;
}

@end