#import <Foundation/Foundation.h>

@class igXMLElement;

@interface igXMLParser : NSObject <NSXMLParserDelegate>

@property(nonatomic, strong) NSXMLParser *xmlParser;
@property(nonatomic, strong) igXMLElement *rootElement;
@property(nonatomic, strong) igXMLElement *currentElementPointer;

- (igXMLElement *)parseXmlWithUrl:(NSURL *)urlString;

- (igXMLElement *)parseXmlWithData:(NSData *)data;

@end

@interface igXMLElement : NSObject

@property(nonatomic, strong) NSString *name;
@property(nonatomic, strong) NSString *text;
@property(nonatomic, strong) NSDictionary *attributes;
@property(nonatomic, strong) NSMutableArray *subElements;
@property(nonatomic, strong) igXMLElement *parent;

- (NSMutableArray *)findElementByName:(NSString *)elementName;

@end